/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.wahlvorschlagsperson.entity;

@javax.persistence.NamedQueries(
 {



   
      @javax.persistence.NamedQuery(
     name="WAHLVORSCHLAGS_PERSON.CountByWahlvorschlagAndTyp",
     query="select COUNT(o) from WahlvorschlagsPerson o WHERE o.wahlvorschlag = ?1 AND o.wahlvorschlagsPersonTyp IN (?2 )",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="WAHLVORSCHLAGS_PERSON.CountUnterstuetzerGeeignetByWahlvorschlag",
     query="SELECT COUNT (wp) FROM WahlvorschlagsPerson wp where wp.wahlvorschlag = ?1 and wp.wahlvorschlagsPersonTyp = de.ivu.elect.business.wahlvorschlagsperson.entity.WahlvorschlagsPersonTyp.UNTERSTUETZER and wp.personStatus = de.ivu.elect.business.person.entity.PersonStatus.GEEIGNET",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="WAHLVORSCHLAGS_PERSON.CountUnterstuetzerNichtGeeignetByWahlvorschlag",
     query="SELECT COUNT (wp) FROM WahlvorschlagsPerson wp where wp.wahlvorschlag = ?1 and wp.wahlvorschlagsPersonTyp = de.ivu.elect.business.wahlvorschlagsperson.entity.WahlvorschlagsPersonTyp.UNTERSTUETZER and wp.personStatus = de.ivu.elect.business.person.entity.PersonStatus.NICHT_GEEIGNET",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="WAHLVORSCHLAGS_PERSON.MaxEingangssequenznummerByWahlvorschlagAndTyp",
     query="SELECT MAX(o.eingangssequenznummer) FROM WahlvorschlagsPerson o WHERE o.wahlvorschlag =?1 AND o.wahlvorschlagsPersonTyp=?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="WAHLVORSCHLAGS_PERSON.MaxUnterstuetzerEingangssequenznummerGroupedByWahlvorschlag",
     query="SELECT new de.ivu.elect.business.unterstuetzer.control.UnterstuetzerEingangssequenznummer(w.id, MAX(p.eingangssequenznummer)) FROM WahlvorschlagsPerson p, Wahlvorschlag w WHERE p.wahlvorschlag = w AND p.wahlvorschlagsPersonTyp = de.ivu.elect.business.wahlvorschlagsperson.entity.WahlvorschlagsPersonTyp.UNTERSTUETZER GROUP BY w.id",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="WAHLVORSCHLAGS_PERSON.TypAndWahlAndOrdnungsmerkmal",
     query="SELECT obj FROM WahlvorschlagsPerson obj WHERE obj.wahlvorschlagsPersonTyp = ?1 AND obj.wahl = ?2 AND obj.externesOrdnungsmerkmal = ?3",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="WAHLVORSCHLAGS_PERSON.WahlOhneUnterstuetzer",
     query="select wp from WahlvorschlagsPerson wp where wp.wahl = ?1 and wp.wahlvorschlagsPersonTyp != de.ivu.elect.business.wahlvorschlagsperson.entity.WahlvorschlagsPersonTyp.UNTERSTUETZER",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="WAHLVORSCHLAGS_PERSON.WahlvorschlagAndEingangssequenznummer",
     query="SELECT obj FROM WahlvorschlagsPerson obj WHERE obj.wahlvorschlagsPersonTyp = ?2 AND obj.wahlvorschlag = ?1 AND obj.eingangssequenznummer = ?3",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="WAHLVORSCHLAGS_PERSON.WahlvorschlagAndStatusOhneUnterstuetzer",
     query="select wp from WahlvorschlagsPerson wp where wp.wahlvorschlag = ?1 and wp.wahlvorschlagsPersonTyp != de.ivu.elect.business.wahlvorschlagsperson.entity.WahlvorschlagsPersonTyp.UNTERSTUETZER and wp.personStatus = ?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="WAHLVORSCHLAGS_PERSON.Wahlvorschlag",
     query="select wp from WahlvorschlagsPerson wp where wp.wahlvorschlag = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="WAHLVORSCHLAGS_PERSON.WahlvorschlagOhneUnterstuetzer",
     query="select wp from WahlvorschlagsPerson wp where wp.wahlvorschlag = ?1 and wp.wahlvorschlagsPersonTyp != de.ivu.elect.business.wahlvorschlagsperson.entity.WahlvorschlagsPersonTyp.UNTERSTUETZER",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "WAHLVORSCHLAGS_PERSON")
@javax.persistence.Cacheable
@javax.persistence.PrimaryKeyJoinColumn(name="personendaten_id")
@javax.persistence.DiscriminatorValue(WahlvorschlagsPerson.DISCRIMINATOR_VALUE)

public
 class WahlvorschlagsPerson
extends AbstractWahlvorschlagsPerson
  {

  private static final long serialVersionUID = 0L;

  public static final String DISCRIMINATOR_VALUE = "WAHLVORSCHLAGS_PERSON";

  /**
   * default constructor (protected, da mit CustomData aufgerufen werden muss)
   */
  protected WahlvorschlagsPerson() {
    super();
  }
    public WahlvorschlagsPerson(de.ivu.elect.jee.entity.customdata.CustomData customData){
        super(customData);
      }



    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public WahlvorschlagsPerson(WahlvorschlagsPerson original){
      original.copyEntity(this);
    }


  @Override
  public void resetAttributeChanged() {
        hasChangedDatumUnterschrift = false;
          hasChangedEingangssequenznummer = false;
          hasChangedErstellungErfasser = false;
          hasChangedErstellungZeitpunkt = false;
          hasChangedWahlvorschlagsPersonTyp = false;
  
      hasChangedErstellungOrt = false;
        hasChangedWahlvorschlag = false;
  

          hasChangedEintragungslisteEintragsByWahlvorschlagsPerson = false;
              
    super.resetAttributeChanged();
  }


  /**
   * ATTRIBUTE
   */

    
  @javax.persistence.Temporal(javax.persistence.TemporalType.DATE)
  @javax.persistence.Column(name = "DATUM_UNTERSCHRIFT", nullable = WahlvorschlagsPersonConstants.DATUM_UNTERSCHRIFT_NULLABLE, precision=WahlvorschlagsPersonConstants.DATUM_UNTERSCHRIFT_PRECISION)
    
  protected java.util.Date datumUnterschrift =  null;

  @javax.persistence.Transient
  protected boolean hasChangedDatumUnterschrift = false;

  public boolean hasChangedDatumUnterschrift(){
    return hasChangedDatumUnterschrift;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertDatumUnterschrift = false;
     @javax.persistence.Transient
     private transient java.util.Date wertNachLadenDatumUnterschrift;
  
  /**
   * 
   *
   * getter for WAHLVORSCHLAGS_PERSON.DATUM_UNTERSCHRIFT
   */
  @javax.annotation.Nullable   @Override   public  java.util.Date getDatumUnterschrift() {
              if (datumUnterschrift == null){
            return null;
          } else {
                          return datumUnterschrift;
          }
      }

  /**
   * 
   *
   * setter for WAHLVORSCHLAGS_PERSON.DATUM_UNTERSCHRIFT
   *
   * @param datumUnterschrift
   */
  @Override   public void setDatumUnterschrift(@javax.annotation.Nullable  java.util.Date datumUnterschrift) {

       resetTkCache();
                  java.util.Date datumUnterschriftInternal = de.ivu.elect.jee.entity.EntityUtil.normalizeDate(datumUnterschrift);
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.datumUnterschrift
      , datumUnterschriftInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedDatumUnterschrift |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("datumUnterschrift");
      }


             if (!isSeitLadenVeraendertDatumUnterschrift) {
          isSeitLadenVeraendertDatumUnterschrift = thisAttributChanged;
         if (isSeitLadenVeraendertDatumUnterschrift){
           wertNachLadenDatumUnterschrift=this.datumUnterschrift;
         }
       }
      

       this.datumUnterschrift = datumUnterschriftInternal;

         }

        
      @javax.persistence.Column(name = "EINGANGSSEQUENZNUMMER", nullable = WahlvorschlagsPersonConstants.EINGANGSSEQUENZNUMMER_NULLABLE, precision=WahlvorschlagsPersonConstants.EINGANGSSEQUENZNUMMER_PRECISION, scale=WahlvorschlagsPersonConstants.EINGANGSSEQUENZNUMMER_SCALE)
            
  protected java.lang.Long eingangssequenznummer =  null;

  @javax.persistence.Transient
  protected boolean hasChangedEingangssequenznummer = false;

  public boolean hasChangedEingangssequenznummer(){
    return hasChangedEingangssequenznummer;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertEingangssequenznummer = false;
     @javax.persistence.Transient
     private transient java.lang.Long wertNachLadenEingangssequenznummer;
  
  /**
   * 
   *
   * getter for WAHLVORSCHLAGS_PERSON.EINGANGSSEQUENZNUMMER
   */
    @Override   public  java.lang.Long getEingangssequenznummer() {
        return eingangssequenznummer;
      }

  /**
   * 
   *
   * setter for WAHLVORSCHLAGS_PERSON.EINGANGSSEQUENZNUMMER
   *
   * @param eingangssequenznummer
   */
  @Override   public void setEingangssequenznummer( java.lang.Long eingangssequenznummer) {

       resetTkCache();
                  java.lang.Long eingangssequenznummerInternal = eingangssequenznummer;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.eingangssequenznummer
      , eingangssequenznummerInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedEingangssequenznummer |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("eingangssequenznummer");
      }


             if (!isSeitLadenVeraendertEingangssequenznummer) {
          isSeitLadenVeraendertEingangssequenznummer = thisAttributChanged;
         if (isSeitLadenVeraendertEingangssequenznummer){
           wertNachLadenEingangssequenznummer=this.eingangssequenznummer;
         }
       }
      

       this.eingangssequenznummer = eingangssequenznummerInternal;

         }

        
  @javax.persistence.Column(name = "ERSTELLUNG_ERFASSER", nullable = WahlvorschlagsPersonConstants.ERSTELLUNG_ERFASSER_NULLABLE, length=WahlvorschlagsPersonConstants.ERSTELLUNG_ERFASSER_MAX_LENGTH)
        
  protected java.lang.String erstellungErfasser =  null;

  @javax.persistence.Transient
  protected boolean hasChangedErstellungErfasser = false;

  public boolean hasChangedErstellungErfasser(){
    return hasChangedErstellungErfasser;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertErstellungErfasser = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenErstellungErfasser;
  
  /**
   * 
   *
   * getter for WAHLVORSCHLAGS_PERSON.ERSTELLUNG_ERFASSER
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getErstellungErfasser() {
        return erstellungErfasser;
      }

  /**
   * 
   *
   * setter for WAHLVORSCHLAGS_PERSON.ERSTELLUNG_ERFASSER
   *
   * @param erstellungErfasser
   */
  @Override   public void setErstellungErfasser(@javax.annotation.Nullable  java.lang.String erstellungErfasser) {

       resetTkCache();
                  
                          java.lang.String erstellungErfasserInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(erstellungErfasser, WahlvorschlagsPersonConstants.ERSTELLUNG_ERFASSER_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.erstellungErfasser
      , erstellungErfasserInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedErstellungErfasser |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("erstellungErfasser");
      }


             if (!isSeitLadenVeraendertErstellungErfasser) {
          isSeitLadenVeraendertErstellungErfasser = thisAttributChanged;
         if (isSeitLadenVeraendertErstellungErfasser){
           wertNachLadenErstellungErfasser=this.erstellungErfasser;
         }
       }
      

       this.erstellungErfasser = erstellungErfasserInternal;

         }

        
  @javax.persistence.Temporal(javax.persistence.TemporalType.TIMESTAMP)
  @javax.persistence.Column(name = "ERSTELLUNG_ZEITPUNKT", nullable = WahlvorschlagsPersonConstants.ERSTELLUNG_ZEITPUNKT_NULLABLE, precision=WahlvorschlagsPersonConstants.ERSTELLUNG_ZEITPUNKT_PRECISION)
    
  protected java.util.Date erstellungZeitpunkt =  null;

  @javax.persistence.Transient
  protected boolean hasChangedErstellungZeitpunkt = false;

  public boolean hasChangedErstellungZeitpunkt(){
    return hasChangedErstellungZeitpunkt;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertErstellungZeitpunkt = false;
     @javax.persistence.Transient
     private transient java.util.Date wertNachLadenErstellungZeitpunkt;
  
  /**
   * 
   *
   * getter for WAHLVORSCHLAGS_PERSON.ERSTELLUNG_ZEITPUNKT
   */
  @javax.annotation.Nullable   @Override   public  java.util.Date getErstellungZeitpunkt() {
              if (erstellungZeitpunkt == null){
            return null;
          } else {
                          return erstellungZeitpunkt;
          }
      }

  /**
   * 
   *
   * setter for WAHLVORSCHLAGS_PERSON.ERSTELLUNG_ZEITPUNKT
   *
   * @param erstellungZeitpunkt
   */
  @Override   public void setErstellungZeitpunkt(@javax.annotation.Nullable  java.util.Date erstellungZeitpunkt) {

       resetTkCache();
                  java.util.Date erstellungZeitpunktInternal = de.ivu.elect.jee.entity.EntityUtil.normalizeDateTime(erstellungZeitpunkt);
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.erstellungZeitpunkt
      , erstellungZeitpunktInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedErstellungZeitpunkt |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("erstellungZeitpunkt");
      }


             if (!isSeitLadenVeraendertErstellungZeitpunkt) {
          isSeitLadenVeraendertErstellungZeitpunkt = thisAttributChanged;
         if (isSeitLadenVeraendertErstellungZeitpunkt){
           wertNachLadenErstellungZeitpunkt=this.erstellungZeitpunkt;
         }
       }
      

       this.erstellungZeitpunkt = erstellungZeitpunktInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "WAHLVORSCHLAGS_PERSON_TYP", nullable = WahlvorschlagsPersonConstants.WAHLVORSCHLAGS_PERSON_TYP_NULLABLE)
    
  protected de.ivu.elect.business.wahlvorschlagsperson.entity.WahlvorschlagsPersonTyp wahlvorschlagsPersonTyp =  null;

  @javax.persistence.Transient
  protected boolean hasChangedWahlvorschlagsPersonTyp = false;

  public boolean hasChangedWahlvorschlagsPersonTyp(){
    return hasChangedWahlvorschlagsPersonTyp;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertWahlvorschlagsPersonTyp = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.wahlvorschlagsperson.entity.WahlvorschlagsPersonTyp wertNachLadenWahlvorschlagsPersonTyp;
  
  /**
   * 
   *
   * getter for WAHLVORSCHLAGS_PERSON.WAHLVORSCHLAGS_PERSON_TYP
   */
    @Override   public  de.ivu.elect.business.wahlvorschlagsperson.entity.WahlvorschlagsPersonTyp getWahlvorschlagsPersonTyp() {
        return wahlvorschlagsPersonTyp;
      }

  /**
   * 
   *
   * setter for WAHLVORSCHLAGS_PERSON.WAHLVORSCHLAGS_PERSON_TYP
   *
   * @param wahlvorschlagsPersonTyp
   */
  @Override   public void setWahlvorschlagsPersonTyp( de.ivu.elect.business.wahlvorschlagsperson.entity.WahlvorschlagsPersonTyp wahlvorschlagsPersonTyp) {

       resetTkCache();
                  de.ivu.elect.business.wahlvorschlagsperson.entity.WahlvorschlagsPersonTyp wahlvorschlagsPersonTypInternal = wahlvorschlagsPersonTyp;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wahlvorschlagsPersonTyp
      , wahlvorschlagsPersonTypInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedWahlvorschlagsPersonTyp |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("wahlvorschlagsPersonTyp");
      }


             if (!isSeitLadenVeraendertWahlvorschlagsPersonTyp) {
          isSeitLadenVeraendertWahlvorschlagsPersonTyp = thisAttributChanged;
         if (isSeitLadenVeraendertWahlvorschlagsPersonTyp){
           wertNachLadenWahlvorschlagsPersonTyp=this.wahlvorschlagsPersonTyp;
         }
       }
      

       this.wahlvorschlagsPersonTyp = wahlvorschlagsPersonTypInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu ErstellungOrt
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "ERSTELLUNG_ORT_ID", referencedColumnName="BENUTZER_EINSATZORT_ID"))
  protected de.ivu.elect.business.benutzerverwaltung.entity.BenutzerEinsatzort erstellungOrt;

  /**
   * 
   */
  @Override
  public void setErstellungOrt(@javax.annotation.Nullable  de.ivu.elect.business.benutzerverwaltung.entity.BenutzerEinsatzort erstellungOrt){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.erstellungOrt
    , erstellungOrt);

    attributeChanged |= thisAttributChanged;

    hasChangedErstellungOrt |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("erstellungOrt");
    }

    this.erstellungOrt = erstellungOrt;
      }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.benutzerverwaltung.entity.BenutzerEinsatzort getErstellungOrt(){
    return this.erstellungOrt;
  }

  @javax.persistence.Transient
  protected boolean hasChangedErstellungOrt = false;

  public boolean hasChangedErstellungOrt(){
    return hasChangedErstellungOrt;
  }

  /**
   * Beziehung (unidirektional) zu Wahlvorschlag
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "WAHLVORSCHLAG_ID", referencedColumnName="WAHLVORSCHLAG_ID"))
  protected de.ivu.elect.business.wahlvorschlag.entity.Wahlvorschlag wahlvorschlag;

  /**
   * 
   */
  @Override
  public void setWahlvorschlag( de.ivu.elect.business.wahlvorschlag.entity.Wahlvorschlag wahlvorschlag){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wahlvorschlag
    , wahlvorschlag);

    attributeChanged |= thisAttributChanged;

    hasChangedWahlvorschlag |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("wahlvorschlag");
    }

    this.wahlvorschlag = wahlvorschlag;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.wahlvorschlag.entity.Wahlvorschlag getWahlvorschlag(){
    return this.wahlvorschlag;
  }

  @javax.persistence.Transient
  protected boolean hasChangedWahlvorschlag = false;

  public boolean hasChangedWahlvorschlag(){
    return hasChangedWahlvorschlag;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehung 1:N (bidirektional) zu EintragungslisteEintragsByWahlvorschlagsPerson
   *
   */
  @javax.persistence.OneToMany(targetEntity=de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintrag.class, mappedBy="wahlvorschlagsPerson", fetch=javax.persistence.FetchType.LAZY )
// elect deaktiviert, gibt Probleme beim Löschen  @org.hibernate.annotations.Cache(usage = org.hibernate.annotations.CacheConcurrencyStrategy.TRANSACTIONAL)
  protected java.util.Set<de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintrag> eintragungslisteEintragsByWahlvorschlagsPerson;


  /**
   * getter muss read-only verwendet werden, da die Beziehung auf der anderen Seite nicht aktualisiert wird!
   */
  @Override
  public java.util.Set<de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintrag> getEintragungslisteEintragsByWahlvorschlagsPerson(){
    if (eintragungslisteEintragsByWahlvorschlagsPerson == null){
      return  java.util.Collections.<de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintrag>unmodifiableSet(java.util.Collections.<de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintrag>emptySet());
    }

    return java.util.Collections.<de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintrag>unmodifiableSet(this.eintragungslisteEintragsByWahlvorschlagsPerson);
  }

  @javax.persistence.Transient
  private boolean hasChangedEintragungslisteEintragsByWahlvorschlagsPerson = false;

  public boolean hasChangedEintragungslisteEintragsByWahlvorschlagsPerson() {
    return hasChangedEintragungslisteEintragsByWahlvorschlagsPerson;
  }

  /**
   * Hinzufuegen von de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintrag
   */
  @Override
  public void addEintragungslisteEintragByWahlvorschlagsPerson(de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintrag eintragungslisteEintragByWahlvorschlagsPerson){
    try {
      if (!updateRelationship){
        updateRelationship = true;

        if (eintragungslisteEintragByWahlvorschlagsPerson != null){
          if (this.eintragungslisteEintragsByWahlvorschlagsPerson == null) {
            this.eintragungslisteEintragsByWahlvorschlagsPerson = new java.util.HashSet<>();
          }

          boolean isChanged = this.eintragungslisteEintragsByWahlvorschlagsPerson.add(eintragungslisteEintragByWahlvorschlagsPerson);

          if(!hasChangedEintragungslisteEintragsByWahlvorschlagsPerson) {
            hasChangedEintragungslisteEintragsByWahlvorschlagsPerson =  isChanged;
          }

          // andere Seite der Beziehung aktualisieren
          eintragungslisteEintragByWahlvorschlagsPerson.setWahlvorschlagsPerson(this);
        }
      }
    } finally {
      updateRelationship = false;
    }
  }

  /**
   * Entfernen von de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintrag
   */
  @Override
  public void removeEintragungslisteEintragByWahlvorschlagsPerson(de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintrag eintragungslisteEintragByWahlvorschlagsPerson){
    try {
      if (!updateRelationship){
        updateRelationship = true;

        if (eintragungslisteEintragByWahlvorschlagsPerson != null){
          if (this.eintragungslisteEintragsByWahlvorschlagsPerson != null) {
            boolean isChanged = this.eintragungslisteEintragsByWahlvorschlagsPerson.remove(eintragungslisteEintragByWahlvorschlagsPerson);

            if(!hasChangedEintragungslisteEintragsByWahlvorschlagsPerson) {
              hasChangedEintragungslisteEintragsByWahlvorschlagsPerson =  isChanged;
            }
          }

          // andere Seite der Beziehung aktualisieren
          eintragungslisteEintragByWahlvorschlagsPerson.setWahlvorschlagsPerson(null);
        }
      }
    } finally {
      updateRelationship = false;
    }
  }

 /**
  * Entfernen von allen de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintrag
  */
   @Override
   public void removeAllEintragungslisteEintragByWahlvorschlagsPersons(){
     java.util.Set<de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintrag> toRemove = new java.util.HashSet<>(getEintragungslisteEintragsByWahlvorschlagsPerson());

     for (   de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintrag entity:toRemove){
       removeEintragungslisteEintragByWahlvorschlagsPerson(entity);
     }
   }

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("WahlvorschlagsPerson:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(WahlvorschlagsPerson other){
        super.copyEntity(other);
                             other.datumUnterschrift = this.datumUnterschrift;
                                other.eingangssequenznummer = this.eingangssequenznummer;
                                other.erstellungErfasser = this.erstellungErfasser;
                                other.erstellungZeitpunkt = this.erstellungZeitpunkt;
                                other.wahlvorschlagsPersonTyp = this.wahlvorschlagsPersonTyp;
           
  other.setErstellungOrt(this.getErstellungOrt());
  other.setWahlvorschlag(this.getWahlvorschlag());


  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(WahlvorschlagsPerson.class)){
        copyEntityAttributesUsingSetter((WahlvorschlagsPerson) other.castTo(WahlvorschlagsPerson.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von WahlvorschlagsPerson: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(WahlvorschlagsPerson other){
      super.copyEntityAttributesUsingSetter(other);
               other.setDatumUnterschrift(this.datumUnterschrift);
                  other.setEingangssequenznummer(this.eingangssequenznummer);
                  other.setErstellungErfasser(this.erstellungErfasser);
                  other.setErstellungZeitpunkt(this.erstellungZeitpunkt);
                  other.setWahlvorschlagsPersonTyp(this.wahlvorschlagsPersonTyp);
       
  }

    @Override
    public void copyEntityAttributesUsingSetter(de.ivu.elect.business.person.entity.Personendaten other){
       if (other.isInstanceOf(WahlvorschlagsPerson.class)) {
         copyEntityAttributesUsingSetter(other.castTo(WahlvorschlagsPerson.class).getEntity());
       } else {
         super.copyEntityAttributesUsingSetter(other);
       }
    }

  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(WahlvorschlagsPerson other){
       super.copyChangedEntityAttributesUsingSetter(other);
                       if (hasChangedDatumUnterschrift) {
        other.setDatumUnterschrift(this.datumUnterschrift);
      }
                             if (hasChangedEingangssequenznummer) {
        other.setEingangssequenznummer(this.eingangssequenznummer);
      }
                             if (hasChangedErstellungErfasser) {
        other.setErstellungErfasser(this.erstellungErfasser);
      }
                             if (hasChangedErstellungZeitpunkt) {
        other.setErstellungZeitpunkt(this.erstellungZeitpunkt);
      }
                             if (hasChangedWahlvorschlagsPersonTyp) {
        other.setWahlvorschlagsPersonTyp(this.wahlvorschlagsPersonTyp);
      }
             }

    @Override
    public void copyChangedEntityAttributesUsingSetter(de.ivu.elect.business.person.entity.Personendaten other){
      if (other.isInstanceOf(WahlvorschlagsPerson.class)) {
        copyChangedEntityAttributesUsingSetter(other.castTo(WahlvorschlagsPerson.class).getEntity());
      } else {
        super.copyChangedEntityAttributesUsingSetter(other);
      }
    }




    @javax.persistence.Transient
    private transient WahlvorschlagsPersonTK tkCache;

    @Override
    protected void resetTkCache() {
    super.resetTkCache();
        tkCache = null;
    }

    public WahlvorschlagsPersonTK getWahlvorschlagsPersonTK(){
    if (tkCache==null) {
    tkCache = new WahlvorschlagsPersonTK(



  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getWahlvorschlagsPersonTK();
    }

  @Override
  public WahlvorschlagsPersonUK getUk(){
    return getWahlvorschlagsPersonUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return WahlvorschlagsPerson.class;
  }

public WahlvorschlagsPersonUK getWahlvorschlagsPersonUK(){

   return  new WahlvorschlagsPersonUK(



  );
}

  @javax.persistence.Transient
  private transient WahlvorschlagsPersonProperties properties;

  @Override
  public WahlvorschlagsPersonProperties getProperties(){
    if (properties == null) {
      properties = new WahlvorschlagsPersonProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public WahlvorschlagsPersonProperties getWahlvorschlagsPersonProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return WahlvorschlagsPersonConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
        if (super.isAenderungenProtokollieren()){
      return true;
    }
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
            super.setProtokollierteAttributeMitWerten(werteVorher);
     
      if (werteVorher.containsKey(WahlvorschlagsPersonConstants.MESSAGE_KEY_DATUM_UNTERSCHRIFT_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WahlvorschlagsPersonConstants.MESSAGE_KEY_DATUM_UNTERSCHRIFT_EINZAHL);

        datumUnterschrift =
     vorher.getAttributTyp().getValueAsDate(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(WahlvorschlagsPersonConstants.MESSAGE_KEY_EINGANGSSEQUENZNUMMER_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WahlvorschlagsPersonConstants.MESSAGE_KEY_EINGANGSSEQUENZNUMMER_EINZAHL);

        eingangssequenznummer =
                        vorher.getAttributTyp().getValueAsLong(vorher.getWertVorher());
                  }

            
      if (werteVorher.containsKey(WahlvorschlagsPersonConstants.MESSAGE_KEY_ERSTELLUNG_ERFASSER_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WahlvorschlagsPersonConstants.MESSAGE_KEY_ERSTELLUNG_ERFASSER_EINZAHL);

        erstellungErfasser =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(WahlvorschlagsPersonConstants.MESSAGE_KEY_ERSTELLUNG_ZEITPUNKT_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WahlvorschlagsPersonConstants.MESSAGE_KEY_ERSTELLUNG_ZEITPUNKT_EINZAHL);

        erstellungZeitpunkt =
     vorher.getAttributTyp().getValueAsDate(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(WahlvorschlagsPersonConstants.MESSAGE_KEY_WAHLVORSCHLAGS_PERSON_TYP_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WahlvorschlagsPersonConstants.MESSAGE_KEY_WAHLVORSCHLAGS_PERSON_TYP_EINZAHL);

        wahlvorschlagsPersonTyp =
     (de.ivu.elect.business.wahlvorschlagsperson.entity.WahlvorschlagsPersonTyp) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = super.getProtokollierteAttributeMitWerten();
                        if (isSeitLadenVeraendertDatumUnterschrift) {
      result.put(WahlvorschlagsPersonConstants.MESSAGE_KEY_DATUM_UNTERSCHRIFT_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.DATE
                , wertNachLadenDatumUnterschrift , datumUnterschrift));
    }
                            if (isSeitLadenVeraendertEingangssequenznummer) {
      result.put(WahlvorschlagsPersonConstants.MESSAGE_KEY_EINGANGSSEQUENZNUMMER_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
                                    de.ivu.elect.jee.protokollierung.AttributTyp.LONG
                            , wertNachLadenEingangssequenznummer , eingangssequenznummer));
    }
                            if (isSeitLadenVeraendertErstellungErfasser) {
      result.put(WahlvorschlagsPersonConstants.MESSAGE_KEY_ERSTELLUNG_ERFASSER_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenErstellungErfasser , erstellungErfasser));
    }
                            if (isSeitLadenVeraendertErstellungZeitpunkt) {
      result.put(WahlvorschlagsPersonConstants.MESSAGE_KEY_ERSTELLUNG_ZEITPUNKT_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.TIMESTAMP
                , wertNachLadenErstellungZeitpunkt , erstellungZeitpunkt));
    }
                            if (isSeitLadenVeraendertWahlvorschlagsPersonTyp) {
      result.put(WahlvorschlagsPersonConstants.MESSAGE_KEY_WAHLVORSCHLAGS_PERSON_TYP_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenWahlvorschlagsPersonTyp , wahlvorschlagsPersonTyp));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
        super.resetProtokollierteAttribute();
                      isSeitLadenVeraendertDatumUnterschrift = false;
      wertNachLadenDatumUnterschrift = null;
                          isSeitLadenVeraendertEingangssequenznummer = false;
      wertNachLadenEingangssequenznummer = null;
                          isSeitLadenVeraendertErstellungErfasser = false;
      wertNachLadenErstellungErfasser = null;
                          isSeitLadenVeraendertErstellungZeitpunkt = false;
      wertNachLadenErstellungZeitpunkt = null;
                          isSeitLadenVeraendertWahlvorschlagsPersonTyp = false;
      wertNachLadenWahlvorschlagsPersonTyp = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
           java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = super.getFachlichAbhaengigeEntitaeten();
                            return result;
  }

        
            @Override
            protected String getInitialDiscriminator() {
              return "WAHLVORSCHLAGS_PERSON";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  @Override
  public boolean isPersistent() {
    return getId() != null;
  }



            
                  @Override
                public void resetValidation() {
                  super.resetValidation();
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                          @Override
                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                  validationResult.addAll(super.validateEntity());
                                                                                                                            de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(eingangssequenznummer, this, WahlvorschlagsPersonConstants.MESSAGE_KEY_EINGANGSSEQUENZNUMMER_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkValueRange(WahlvorschlagsPersonConstants.EINGANGSSEQUENZNUMMER_MAX_VALUE, WahlvorschlagsPersonConstants.EINGANGSSEQUENZNUMMER_MIN_VALUE, eingangssequenznummer, this, WahlvorschlagsPersonConstants.MESSAGE_KEY_EINGANGSSEQUENZNUMMER_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(WahlvorschlagsPersonConstants.ERSTELLUNG_ERFASSER_MAX_LENGTH ,  erstellungErfasser, this, WahlvorschlagsPersonConstants.MESSAGE_KEY_ERSTELLUNG_ERFASSER_EINZAHL, validationResult);
                                                                                                                    de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(wahlvorschlagsPersonTyp, this, WahlvorschlagsPersonConstants.MESSAGE_KEY_WAHLVORSCHLAGS_PERSON_TYP_EINZAHL, validationResult);
                                                                    }
             return validationResult;
        }

            }
